/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   immediate_assert.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_IMMEDIATE_ASSERT_H
#define UHDM_IMMEDIATE_ASSERT_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class immediate_assert : public assertion {
  public:
    // Implicit constructor used to initialize all members,
    // comment: immediate_assert();
    ~immediate_assert() final {}
    
    const BaseClass* VpiParent() const final { return vpiParent_; }

    bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    unsigned int UhdmParentType() const final { return uhdmParentType_; }

    bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    const std::string& VpiFile() const final;

    bool VpiFile(const std::string& data) final;

    unsigned int VpiLineNo() const final { return vpiLineNo_; }

    bool VpiLineNo(unsigned int data) final { vpiLineNo_ = data; return true;}

    int VpiIsDeferred() const { return vpiIsDeferred_; }

    bool VpiIsDeferred(int data) { vpiIsDeferred_ = data; return true;}

    int VpiIsFinal() const { return vpiIsFinal_; }

    bool VpiIsFinal(int data) { vpiIsFinal_ = data; return true;}

    const expr* Expr() const { return expr_; }

    bool Expr(expr* data) { expr_ = data; return true;}

    const any* Stmt() const { return stmt_; }

    bool Stmt(any* data) {if (!stmtGroupCompliant(data)) return false; stmt_ = data; return true;}

    const any* Else_stmt() const { return else_stmt_; }

    bool Else_stmt(any* data) {if (!stmtGroupCompliant(data)) return false; else_stmt_ = data; return true;}

    unsigned int VpiType() { return vpiImmediateAssert; }

    UHDM_OBJECT_TYPE UhdmType() const final { return uhdmimmediate_assert; }   
  private:
    
    BaseClass* vpiParent_;

    unsigned int uhdmParentType_;

    SymbolFactory::ID vpiFile_;

    unsigned int vpiLineNo_;

    int vpiIsDeferred_;

    int vpiIsFinal_;

    expr* expr_;

    any* stmt_;

    any* else_stmt_;

  };

  
  class immediate_assertFactory {
  friend Serializer;
  public:
  immediate_assert* Make() {
    immediate_assert* obj = new immediate_assert();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<immediate_assert*> objects_;
  };
  
  
  class VectorOfimmediate_assertFactory {
  friend Serializer;
  public:
  std::vector<immediate_assert*>* Make() {
    std::vector<immediate_assert*>* obj = new std::vector<immediate_assert*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<immediate_assert*>*> objects_;
  };

};

#endif

