/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   instance.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_INSTANCE_H
#define UHDM_INSTANCE_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class instance : public scope {
  public:
    // Implicit constructor used to initialize all members,
    // comment: instance();
    virtual ~instance()  {}
    
    const std::string& VpiDefName() const;

    bool VpiDefName(const std::string& data);

    bool VpiArrayMember() const { return vpiArrayMember_; }

    bool VpiArrayMember(bool data) { vpiArrayMember_ = data; return true;}

    bool VpiCellInstance() const { return vpiCellInstance_; }

    bool VpiCellInstance(bool data) { vpiCellInstance_ = data; return true;}

    int VpiDefNetType() const { return vpiDefNetType_; }

    bool VpiDefNetType(int data) { vpiDefNetType_ = data; return true;}

    const std::string& VpiDefFile() const;

    bool VpiDefFile(const std::string& data);

    int VpiDefDelayMode() const { return vpiDefDelayMode_; }

    bool VpiDefDelayMode(int data) { vpiDefDelayMode_ = data; return true;}

    bool VpiProtected() const { return vpiProtected_; }

    bool VpiProtected(bool data) { vpiProtected_ = data; return true;}

    int VpiTimePrecision() const { return vpiTimePrecision_; }

    bool VpiTimePrecision(int data) { vpiTimePrecision_ = data; return true;}

    int VpiTimeUnit() const { return vpiTimeUnit_; }

    bool VpiTimeUnit(int data) { vpiTimeUnit_ = data; return true;}

    int VpiUnconnDrive() const { return vpiUnconnDrive_; }

    bool VpiUnconnDrive(int data) { vpiUnconnDrive_ = data; return true;}

    const std::string& VpiLibrary() const;

    bool VpiLibrary(const std::string& data);

    const std::string& VpiCell() const;

    bool VpiCell(const std::string& data);

    const std::string& VpiConfig() const;

    bool VpiConfig(const std::string& data);

    bool VpiAutomatic() const { return vpiAutomatic_; }

    bool VpiAutomatic(bool data) { vpiAutomatic_ = data; return true;}

    bool VpiTop() const { return vpiTop_; }

    bool VpiTop(bool data) { vpiTop_ = data; return true;}

    VectorOftask_func* Task_funcs() const { return task_funcs_; }

    bool Task_funcs(VectorOftask_func* data) { task_funcs_ = data; return true;}

    VectorOfnet* Nets() const { return nets_; }

    bool Nets(VectorOfnet* data) { nets_ = data; return true;}

    VectorOfarray_net* Array_nets() const { return array_nets_; }

    bool Array_nets(VectorOfarray_net* data) { array_nets_ = data; return true;}

    VectorOfassertion* Assertions() const { return assertions_; }

    bool Assertions(VectorOfassertion* data) { assertions_ = data; return true;}

    VectorOfclass_defn* Class_defns() const { return class_defns_; }

    bool Class_defns(VectorOfclass_defn* data) { class_defns_ = data; return true;}

    const instance* Instance() const { return instance_; }

    bool Instance(instance* data) { instance_ = data; return true;}

    VectorOfprogram* Programs() const { return programs_; }

    bool Programs(VectorOfprogram* data) { programs_ = data; return true;}

    VectorOfprogram* Program_arrays() const { return program_arrays_; }

    bool Program_arrays(VectorOfprogram* data) { program_arrays_ = data; return true;}

    VectorOfspec_param* Spec_params() const { return spec_params_; }

    bool Spec_params(VectorOfspec_param* data) { spec_params_ = data; return true;}

    const module* Module() const { return module_; }

    bool Module(module* data) { module_ = data; return true;}

   virtual  UHDM_OBJECT_TYPE UhdmType() const override { return uhdminstance; }   
  private:
    
    SymbolFactory::ID vpiDefName_;

    bool vpiArrayMember_;

    bool vpiCellInstance_;

    int vpiDefNetType_;

    SymbolFactory::ID vpiDefFile_;

    int vpiDefDelayMode_;

    bool vpiProtected_;

    int vpiTimePrecision_;

    int vpiTimeUnit_;

    int vpiUnconnDrive_;

    SymbolFactory::ID vpiLibrary_;

    SymbolFactory::ID vpiCell_;

    SymbolFactory::ID vpiConfig_;

    bool vpiAutomatic_;

    bool vpiTop_;

    VectorOftask_func* task_funcs_;

    VectorOfnet* nets_;

    VectorOfarray_net* array_nets_;

    VectorOfassertion* assertions_;

    VectorOfclass_defn* class_defns_;

    instance* instance_;

    VectorOfprogram* programs_;

    VectorOfprogram* program_arrays_;

    VectorOfspec_param* spec_params_;

    module* module_;

  };

 #if 0 // This class cannot be instantiated 
  class instanceFactory {
  friend Serializer;
  public:
  instance* Make() {
    instance* obj = new instance();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<instance*> objects_;
  };
 #endif 
  
  class VectorOfinstanceFactory {
  friend Serializer;
  public:
  std::vector<instance*>* Make() {
    std::vector<instance*>* obj = new std::vector<instance*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<instance*>*> objects_;
  };

};

#endif

